Developer Network NREL NREL Developer Network

GET /api/alt-fuel-stations/v1

Return a full list of alternative fuel stations that match your query.

    Request URL

    GET http://developer.nrel.gov/api/alt-fuel-stations/v1.format?parameters

    Request Parameters

    The following query parameters may be passed in the request to control the output:

    Parameter Required Value Description
    format Yes
    Type: string
    Default: None
    Options: json, xml, csv

    The output response format. Given in the URL as the file extension.

    api_key Yes
    Type: string
    Default: None

    Your developer API key. See API key usage for more information.

    status No
    Type: string
    Default: all
    Options: all, E, P

    Return stations that match the given status. A single status, or a comma-separated list of multiple statuses, may be given.

    Option Description
    all Include both open and planned stations.
    E Open: The station is open and carries alternative fuel.
    P Planned: The station is not yet open, but plans to carry alternative fuel in the future, or the station is temporarily out of service.
    access No
    Type: string
    Default: all
    Options: all, public, private

    Return stations with the given access type.

    fuel_type No
    Type: string
    Default: all
    Options: all, BD, CNG, E85, ELEC, HY, LNGLPG

    Return stations that supply any of the given fuel types. A single fuel type, or a comma-separated list of multiple fuel types, may be given.

    Option Description
    all Include all fuel types
    BD Biodiesel (B20 and above)
    CNG Compressed Natural Gas
    E85 Ethanol (E85)
    ELEC Electric
    HY Hydrogen
    LNG Liquefied Natural Gas
    LPG Liquefied Petroleum Gas (Propane)
    cards_accepted No
    Type: string
    Default: all
    Options: all, A, D, M, V, Cash, Checks, CFN, CleanEnergy, FuelMan, GasCard, PHH, Voyager, Wright_Exp

    Return stations that accept any of the given payment methods. A single payment method, or a comma-separated list of multiple payment methods, may be given.

    Option Description
    all Include all payment types
    A American Express
    D Discover
    M MasterCard
    V Visa
    Cash  
    Checks  
    CFN  
    CleanEnergy  
    FuelMan  
    GasCard  
    PHH PHH Services
    Wright_Exp Wright Express
    owner_type No
    Type: string
    Default: all
    Options: all, FG, LG, P, SG, T

    Return stations owned by the given types of owners. A single owner type, or a comma-separated list of multiple owner types, may be given.

    Option Description
    all Include all owner types
    P Privately owned
    T Utility owned
    FG Federal government owned
    LG Local government owned
    SG State government owned
    J Jointly owned (combination of owner types)
    federal_agency_id No
    Type: integer
    Default: all
    Options: all, (see table to right for IDs)

    Return stations owned by the given federal agency. A federal agency ID, or a comma-separated list of multiple federal agency IDs, may be given.

    Option Description
    all Include all stations, regardless of federal agency owner
    3 Defense Agencies
    4 U.S. Department of Agriculture
    5 Department of Air Force
    6 Department of Army
    7 Department of Commerce
    8 U.S. Department of Energy
    9 Department of Health and Human Services
    10 Department of Homeland Security
    12 Department of Justice
    14 Department of Navy
    16 Department of the Interior
    17 U.S. Department of Transportation
    19 Department of Veterans Affairs
    20 U.S. Environmental Protection Agency
    22 National Aeronautics and Space Administration
    23 Smithsonian Institution
    24 Social Security Administration
    25 U.S. Postal Service
    26 United States Marine Corps
    ev_network No
    Type: string
    Default: all
    Options: all, Blink Network, ChargeNet, ChargePoint Network, eVgo Network, EVSE LLC WebNet, RechargeAccess, Rideshare Online, Shorepower

    Return only electric charging stations that belong to the given network. A single network, or a comma separate list of multiple networks, may be given.

    Option
    all
    Blink Network
    ChargeNet
    ChargePoint Network
    eVgo Network
    EVSE LLC WebNet
    RechargeAccess
    Rideshare Online
    Shorepower
    ev_charging_level No
    Type: string
    Default: all
    Options: all, 1, 2, dc_fast

    Return only electric charging stations that provide the given level of electric vehicle supply equipment (EVSE).

    Option Description
    all Include all charging levels
    1 Level 1 EVSE (standard 110V outlet)
    2 Level 2 EVSE (J1772 connector)
    dc_fast DC Fast Charging
    state No
    Type: string
    Default: None
    Return only stations within the given state. State must be given as a two character state code (eg, "CO" for Colorado). A single state, or a comma-separate list of multiple states, may be given.
    zip No
    Type: string
    Default: None
    Return only stations within the given ZIP code. ZIP codes must be exactly 5 digits long. A single ZIP code, or a comma-separate list of multiple ZIP codes, may be given.
    limit No
    Type: integer
    Default: None
    Minimum: 1
    The maximum number of results to return. Note: Since results are returned in no specific order, this has limited use, other than for testing purposes.

    Response Fields

    The response is composed of the fuel stations matching the requested query. For JSON or XML formats, additional metadata is supplied in the following structure:

    Field Value Description
    total_results
    Type: integer

    How many total stations match your requested query (regardless of any "limit" applied).

    station_locator_url
    Type: string

    The URL of the Alternative Fueling Station Locator, the web application that supplies this data.

    fuel_stations
    Type: array
    An array of matching fuel station records returned in no specific order. See fuel station record fields for response details.

    Fuel Station Record Fields

    The individual fuel station records are returned in no specific order. Each station has the following attributes:

    Field Value Description
    fuel_type_code
    Type: string

    The type of alternative fuel the station provides. Fuel types are given as code values as described below:

    Value Description
    BD Biodiesel (B20 and above)
    CNG Compressed Natural Gas
    E85 Ethanol (E85)
    ELEC Electric
    HY Hydrogen
    LNG Liquefied Natural Gas
    LPG Liquefied Petroleum Gas (Propane)
    station_name
    Type: string
    The name of the station.
    street_address
    Type: string
    The street address of the station's location.
    intersection_directions
    Type: string
    Brief additional information about how to locate the station.
    city
    Type: string
    The city of the station's location.
    state
    Type: string
    The two character U.S. state or Canadian province code of the station's location.
    zip
    Type: string
    The ZIP code (postal code) of the station's location.
    plus4
    Type: string
    The plus-4 portion of the station's ZIP code (U.S. ZIP codes only).
    station_phone
    Type: string
    The phone number of the station.
    status_code
    Type: string

    The current status of the station, given as code values as described below:

    Value Description
    E Open: The station is open.
    P Planned: The station is not yet open, but plans to carry alternative fuel in the future, or the station is temporarily out of service. See the "Expected Date" field for an anticipated open date.
    expected_date
    Type: date
    For planned stations, the date the station is expected to open or start carrying alternative fuel.
    groups_with_access_code
    Type: string
    A description of who is allowed to access the station and other station access information. Stations with the groups_with_access_code "Private - fleet customers only" may allow other entities to fuel through a business-to-business arrangement. For more information, fleet customers should refer to the access_days_time field for contact information or contact the station directly.
    access_days_time
    Type: string
    Hours of operation for the station.
    cards_accepted
    Type: string

    A space-separated list of payment methods accepted. Payment methods are given as code values as described below:

    Value Description
    A American Express
    D Discover
    M MasterCard
    V VISA
    Cash  
    Checks  
    CFN  
    CleanEnergy  
    FuelMan  
    GasCard  
    PHH PHH Services
    Voyager  
    Wright_Exp WEX
    owner_type_code
    Type: string

    A space-separated list of payment methods accepted. Payment methods are given as code values as described below:

    Option Description
    P Privately owned
    T Utility owned
    FG Federal government owned
    LG Local government owned
    SG State government owned
    J Jointly owned (combination of owner types)
    federal_agency
    Type: record
    If the station is owned by a federal agency, a record for the federal agency that owns this station. See federal agency record fields for response details.
    bd_blends
    Type: string
    For biodiesel stations, the level of biodiesel blends the station provides.
    e85_blender_pump
    Type: boolean

    For E85 stations, an indication of whether the station has a blender pump on site, given as a boolean:

    Value Description
    true In addition to E85, the station has a blender pump capable of providing mid-level ethanol blends.
    false The station does not have a blender pump.
    lpg_primary
    Type: boolean

    For propane stations, the type of station, given as a boolean:

    Value Description
    true Primary: A propane station is considered primary because it meets the following criteria, developed based on feedback from the propane industry:
    1. The price of a gallon of propane autogas, including all taxes, at the station is less expensive than other propane sold (e.g., gas grill bottles); and
    2. The station accepts credit cards.
    false Secondary: The station does not meet the criteria to be considered primary.
    ng_fill_type_code
    Type: string

    For CNG stations, the type of dispensing capability available, given as code values as described below:

    Value Description
    Q Quick fill
    T Timed fill
    B Both: quick fill and timed fill
    ng_psi
    Type: string
    For CNG stations, a space separated list of PSI pressures available.
    ng_vehicle_class
    Type: string

    For CNG and LNG stations, the maximum vehicle size that can physically access the fueling infrastructure, given as code values as described below:

    Value Description
    LD Station can only accommodate light-duty vehicles (Classes 1-2).
    MD Station can accommodate light- and medium-duty vehicles (Classes 1-5).
    HD Station can accommodate light-, medium-, and heavy-duty vehicles (Classes 1-8).

    Note: This field does not take into account station capacity or other considerations.

    ev_level1_evse_num
    Type: integer
    For electric stations, the number of Level 1 EVSE (standard 110V outlet).
    ev_level2_evse_num
    Type: integer
    For electric stations, the number of Level 2 EVSE (J1772 connector).
    ev_dc_fast_num
    Type: integer
    For electric stations, the number of DC Fast Chargers.
    ev_other_evse
    Type: string
    For electric stations, the number and type of additional EVSE, such as:
    • SP Inductive - Small paddle inductive
    • LP Inductive - Large paddle inductive
    • Avcon Conductive
    ev_network
    Type: string
    For electric stations, the name of the EVSE network, if applicable.
    ev_network_web
    Type: string
    For electric stations, the EVSE network Web site, if applicable.
    hy_status_link
    Type: string
    For hydrogen stations, a link to a website that provides up-to-date information about the current status of this hydrogen station.
    geocode_status
    Type: string

    A rating indicating the approximate accuracy of the latitude and longitude for the station's address, given as code values as described below:

    Value Description
    GPS The location is from a real GPS readout at the station.
    200-9 Premise (building name, property name, shopping center, etc.) level accuracy.
    200-8 Address level accuracy.
    200-7 Intersection level accuracy.
    200-6 Street level accuracy.
    200-5 ZIP code (postal code) level accuracy.
    200-4 Town (city, village) level accuracy.
    200-3 Sub-region (county, municipality, etc.) level accuracy.
    200-2 Region (state, province, prefecture, etc.) level accuracy.
    200-1 Country level accuracy.
    200-0 Unknown accuracy.
    latitude
    Type: decimal
    Range: -90 to 90
    The latitude of the station's address (see the "Geocode Status" field for details on the latitude's accuracy).
    longitude
    Type: decimal
    Range: -180 to 180
    The longitude of the station's address (see the "Geocode Status" field for details on the longitude's accuracy).
    open_date
    Type: date
    The date that the station began offering the fuel. Please note that LPG (propane) stations do not have open dates.
    date_last_confirmed
    Type: date
    The date the station's details were last confirmed.
    updated_at
    Type: datetime
    The time the station's details were last updated (ISO 8601 format).
    id
    Type: integer
    A unique identifier for this specific station.

    Federal Agency Record Fields

    Field Value Description
    id
    Type: integer
    A unique identifier for the federal agency.
    name
    Type: string
    The name of the federal agency.

    Examples

    JSON Output Format

     1
     2
     3
     4
     5
     6
     7
     8
     9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    19
    20
    21
    22
    23
    24
    25
    26
    27
    28
    29
    30
    31
    32
    33
    34
    35
    36
    37
    38
    39
    40
    41
    42
    43
    44
    45
    46
    47
    48
    49
    50
    51
    52
    53
    54
    55
    56
    57
    58
    59
    60
    61
    62
    63
    64
    65
    66
    67
    68
    69
    70
    71
    72
    73
    74
    75
    76
    77
    78
    79
    80
    {
      "fuel_stations": [
        {
          "access_days_time": "24 hours daily; also accept Propel Clean Drive fleet card",
          "bd_blends": null,
          "cards_accepted": "A D M V FuelMan Voyager Wright_Exp",
          "city": "Fremont",
          "date_last_confirmed": "2013-01-31",
          "expected_date": null,
          "fuel_type_code": "E85",
          "geocode_status": "200-8",
          "groups_with_access_code": "Public - credit card at all times",
          "hy_status_link": null,
          "intersection_directions": "Stevenson Blvd & Paseo Padre Pkwy",
          "latitude": 37.5486034,
          "longitude": -121.9717542,
          "open_date": "2010-08-02",
          "owner_type_code": "P",
          "plus4": null,
          "station_name": "Propel Fuels",
          "station_phone": "800-871-0773",
          "status_code": "E",
          "street_address": "39707 Paseo Padre Pkwy",
          "zip": "94538",
          "state": "CA",
          "ng_fill_type_code": null,
          "ng_psi": null,
          "ng_vehicle_class": null,
          "e85_blender_pump": false,
          "ev_level1_evse_num": null,
          "ev_level2_evse_num": null,
          "ev_dc_fast_num": null,
          "ev_other_evse": null,
          "ev_network": null,
          "ev_network_web": null,
          "lpg_primary": null,
          "id": 35946,
          "updated_at": "2013-02-14T18:43:05Z"
        },
        {
          "access_days_time": "24 hours daily",
          "bd_blends": null,
          "cards_accepted": "A D M V Voyager Wright_Exp",
          "city": "Modesto",
          "date_last_confirmed": "2012-09-30",
          "expected_date": null,
          "fuel_type_code": "E85",
          "geocode_status": "200-8",
          "groups_with_access_code": "Public - credit card at all times",
          "hy_status_link": null,
          "intersection_directions": null,
          "latitude": 37.634028,
          "longitude": -120.9944148,
          "open_date": "2010-06-15",
          "owner_type_code": "P",
          "plus4": null,
          "station_name": "Pacific Pride - Boyett Petroleum",
          "station_phone": "209-577-6000",
          "status_code": "E",
          "street_address": "401 9th St",
          "zip": "95350",
          "state": "CA",
          "ng_fill_type_code": null,
          "ng_psi": null,
          "ng_vehicle_class": null,
          "e85_blender_pump": false,
          "ev_level1_evse_num": null,
          "ev_level2_evse_num": null,
          "ev_dc_fast_num": null,
          "ev_other_evse": null,
          "ev_network": null,
          "ev_network_web": null,
          "lpg_primary": null,
          "id": 35947,
          "updated_at": "2012-10-12T18:28:47Z"
        }
      ],
      "station_locator_url": "http://www.afdc.energy.gov/afdc/locator/stations/",
      "total_results": 1574
    }
    

    XML Output Format

     1
     2
     3
     4
     5
     6
     7
     8
     9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    19
    20
    21
    22
    23
    24
    25
    26
    27
    28
    29
    30
    31
    32
    33
    34
    35
    36
    37
    38
    39
    40
    41
    42
    43
    44
    45
    46
    47
    48
    49
    50
    51
    52
    53
    54
    55
    56
    57
    58
    59
    60
    61
    62
    63
    64
    65
    66
    67
    68
    69
    70
    71
    72
    73
    74
    75
    76
    77
    78
    79
    80
    81
    <?xml version="1.0" encoding="UTF-8"?>
    <response>
      <station-locator-url>http://www.afdc.energy.gov/afdc/locator/stations/</station-locator-url>
      <total-results>1574</total-results>
      <fuel-stations type="array">
        <fuel-station>
          <access-days-time>24 hours daily; also accept Propel Clean Drive fleet card</access-days-time>
          <bd-blends nil="true" />
          <cards-accepted>A D M V FuelMan Voyager Wright_Exp</cards-accepted>
          <city>Fremont</city>
          <date-last-confirmed>2013-01-31</date-last-confirmed>
          <expected-date nil="true" />
          <fuel-type-code>E85</fuel-type-code>
          <geocode-status>200-8</geocode-status>
          <groups-with-access-code>Public - credit card at all times</groups-with-access-code>
          <hy-status-link nil="true" />
          <intersection-directions>Stevenson Blvd &amp; Paseo Padre Pkwy</intersection-directions>
          <latitude>37.5486034</latitude>
          <longitude>-121.9717542</longitude>
          <open-date>2010-08-02</open-date>
          <owner-type-code>P</owner-type-code>
          <plus4 nil="true" />
          <station-name>Propel Fuels</station-name>
          <station-phone>800-871-0773</station-phone>
          <status-code>E</status-code>
          <street-address>39707 Paseo Padre Pkwy</street-address>
          <zip>94538</zip>
          <state>CA</state>
          <ng-fill-type-code nil="true" />
          <ng-psi nil="true" />
          <ng-vehicle-class nil="true" />
          <e85-blender-pump>false</e85-blender-pump>
          <ev-level1-evse-num nil="true" />
          <ev-level2-evse-num nil="true" />
          <ev-dc-fast-num nil="true" />
          <ev-other-evse nil="true" />
          <ev-network nil="true" />
          <ev-network-web nil="true" />
          <lpg-primary nil="true" />
          <id>35946</id>
          <updated-at>2013-02-14T18:43:05Z</updated-at>
        </fuel-station>
        <fuel-station>
          <access-days-time>24 hours daily</access-days-time>
          <bd-blends nil="true" />
          <cards-accepted>A D M V Voyager Wright_Exp</cards-accepted>
          <city>Modesto</city>
          <date-last-confirmed>2012-09-30</date-last-confirmed>
          <expected-date nil="true" />
          <fuel-type-code>E85</fuel-type-code>
          <geocode-status>200-8</geocode-status>
          <groups-with-access-code>Public - credit card at all times</groups-with-access-code>
          <hy-status-link nil="true" />
          <intersection-directions nil="true" />
          <latitude>37.634028</latitude>
          <longitude>-120.9944148</longitude>
          <open-date>2010-06-15</open-date>
          <owner-type-code>P</owner-type-code>
          <plus4 nil="true" />
          <station-name>Pacific Pride - Boyett Petroleum</station-name>
          <station-phone>209-577-6000</station-phone>
          <status-code>E</status-code>
          <street-address>401 9th St</street-address>
          <zip>95350</zip>
          <state>CA</state>
          <ng-fill-type-code nil="true" />
          <ng-psi nil="true" />
          <ng-vehicle-class nil="true" />
          <e85-blender-pump>false</e85-blender-pump>
          <ev-level1-evse-num nil="true" />
          <ev-level2-evse-num nil="true" />
          <ev-dc-fast-num nil="true" />
          <ev-other-evse nil="true" />
          <ev-network nil="true" />
          <ev-network-web nil="true" />
          <lpg-primary nil="true" />
          <id>35947</id>
          <updated-at>2012-10-12T18:28:47Z</updated-at>
        </fuel-station>
      </fuel-stations>
    </response>
    

    CSV Output Format

    1
    2
    3
    Fuel Type Code,Station Name,Street Address,Intersection Directions,City,State,ZIP,Plus4,Station Phone,Status Code,Expected Date,Groups With Access Code,Access Days Time,Cards Accepted,BD Blends,NG Fill Type Code,NG PSI,EV Level1 EVSE Num,EV Level2 EVSE Num,EV DC Fast Count,EV Other Info,EV Network,EV Network Web,Geocode Status,Latitude,Longitude,Date Last Confirmed,ID,Updated At,Owner Type Code,Federal Agency ID,Federal Agency Name,Open Date,Hydrogen Status Link,NG Vehicle Class,LPG Primary,E85 Blender Pump
    E85,Propel Fuels,39707 Paseo Padre Pkwy,Stevenson Blvd & Paseo Padre Pkwy,Fremont,CA,94538,,800-871-0773,E,,Public - credit card at all times,24 hours daily; also accept Propel Clean Drive fleet card,A D M V FuelMan Voyager Wright_Exp,,,,,,,,,,200-8,37.5486034,-121.9717542,2013-01-31,35946,2013-02-14 18:43:05 UTC,P,,,2010-08-02,,,,false
    E85,Pacific Pride - Boyett Petroleum,401 9th St,,Modesto,CA,95350,,209-577-6000,E,,Public - credit card at all times,24 hours daily,A D M V Voyager Wright_Exp,,,,,,,,,,200-8,37.634028,-120.9944148,2012-09-30,35947,2012-10-12 18:28:47 UTC,P,,,2010-06-15,,,,false
    

    Rate Limits

    Standard rate limits apply. No more than 1,000 requests may be made in any hour. No more than 10,000 requests may be made in any day.

    Errors

    Standard errors may be returned. In addition, the following service-specific errors may be returned:

    HTTP Status Code Description
    422 Unprocessable Entity - An invalid value was given for a query parameter. The response body will describe the specific error.
    blog comments powered by Disqus